extern fmov, 200 // 代入
extern fstr, 201 // 文字列変換
extern ffloor, 202 // 切り捨て
extern fadd, 204 // 加算
extern fmul, 206 // 乗算
extern fdiv, 207 // 除算
extern fsin, 208 // 正弦
extern wifiStatus, 3
const WL_CONNECTED = 3
const WHITE = 0xffff
const RED = 0xf800
const GREEN = 0x07e0
const BLUE = 0x001f
const ORANGE = 0x8200
const PINK = 0x8208
const G_START_X = 200
const G_START_Y = 10
const DX = 12
mstruct days {
	MONTH db 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31
}
mstruct calc {
	RESULT rb 4
	TEMP rb 4
	STR rb 20
}
mstruct tm {
	SEC rb 1 // 秒 [0-61] 最大2秒までのうるう秒を考慮
	MIN rb 1 // 分 [0-59]
	HOUR rb 1 // 時 [0-23]
	MDAY rb 1 // 日 [1-31]
	MON rb 1 // 月 [0-11]
	YEAR rb 1 // 年 [1900からの経過年数]
	WDAY rb 1 // 曜日 [0:日 1:月 ... 6:土]
	YDAY rb 2 // 年内の通し日数 [0-365] ビッグエンディアンで格納
	ISDST rb 1 // 夏時間が無効であれば0
}

main()
end

def main() {
	var y
	var m
	var d
	var yyyy
	var mm
	var dd
	var b
	var t
	var days
	if (wifiStatus() != WL_CONNECTED) {
		return
	}
	localtime(tm.SEC)
	yyyy = tm.YEAR[0] + 1900
	mm = tm.MON[0] + 1
	dd = tm.MDAY[0]
	cls
	print "Enter your birthday"
	print
	input "Year = ?", y
	input "Month = ?", m
	input "Day = ?", d
	cursor 0
	cls
	days = getDays(yyyy, mm, dd) - getDays(y, m, d)
	gprint 0, G_START_Y, "[Biorhythm]", ORANGE, 0
	calc(days, 23)
	gprint 0, G_START_Y + 16, "Physical     : ", BLUE, 0
	gprint 120, G_START_Y + 16, ffloor(calc.RESULT), BLUE, 0
	calc(days, 28)
	gprint 0, G_START_Y + 32, "Sensitivity  : ", RED, 0
	gprint 120, G_START_Y + 32, ffloor(calc.RESULT), RED, 0
	calc(days, 33)
	gprint 0, G_START_Y + 48, "Intellectual : ", GREEN, 0
	gprint 120, G_START_Y + 48, ffloor(calc.RESULT), GREEN, 0

	gprint 160, G_START_Y, " 100", WHITE, 0
	gprint 160, G_START_Y + 48, "   0", WHITE, 0
	gprint 160, G_START_Y + 94, "-100", WHITE, 0
	locate 23, 15
	mprint mstrf("\x1b[37m%04d/%02d/%02d ", yyyy, mm, dd)

	draw(days, 23, BLUE)
	draw(days, 28, RED)
	draw(days, 33, GREEN)
	locate 0, 21
}

def draw(days, T, color) {
	var i
	var sx
	var sy
	var ex
	var ey
	rect G_START_X, G_START_Y, DX * 30, 100, PINK, 0
	line G_START_X, G_START_Y + 50, G_START_X + DX * 30, G_START_Y + 50, PINK
	line G_START_X + DX * 2, G_START_Y, G_START_X + DX * 2, G_START_Y + 100, WHITE
	line G_START_X + DX * 9, G_START_Y, G_START_X + DX * 9, G_START_Y + 100, ORANGE
	line G_START_X + DX * 16, G_START_Y, G_START_X + DX * 16, G_START_Y + 100, ORANGE
	line G_START_X + DX * 23, G_START_Y, G_START_X + DX * 23, G_START_Y + 100, ORANGE
	sx = G_START_X
	ex = G_START_X
	for i = days - 2 to days + 27
		sx = ex
		calc(i, T)
		sy = G_START_Y + 50 - ffloor(calc.RESULT) / 2
		ex = sx + DX
		calc(i + 1, T)
		ey = G_START_Y + 50 - ffloor(calc.RESULT) / 2
		line sx, sy, ex, ey, color
	next
}

' 日数(days)と周期(T)からバイオリズムの値を計算します。
def calc(days, T) {
	fmov(calc.RESULT, mstrf("%d", days))

	fmov(calc.TEMP, mstrf("2"))
	fmul(calc.RESULT, calc.RESULT, calc.TEMP)

	fmov(calc.TEMP, mstrf("3.141593"))
	fmul(calc.RESULT, calc.RESULT, calc.TEMP)

	fmov(calc.TEMP, mstrf("%d", T))
	fdiv(calc.RESULT, calc.RESULT, calc.TEMP)

	fsin(calc.RESULT, calc.RESULT)

	fmov(calc.TEMP, mstrf("100"))
	fmul(calc.RESULT, calc.RESULT, calc.TEMP)
}

' 基準日(1952年1月1日)からの日数を取得します。
def getDays(y, m, d) {
	var days
	var i
	days = (y - 1952) * 365 + (y - 1952) / 4 + 1
	i = 0
	while i < m - 1
		days = days + days.MONTH[i]
		i = i + 1
	wend
	days = days + (d - 1)
	return days
}
