'
' ORANGE Operating System
' Copyright (C) 2020 PicoSoft
'
extern wifiStatus, 3
const WL_CONNECTED = 3
const MAX_PATH = 128
const MAX_STRING = 128
const KEY_BUF_SIZE = 128
const TRUE = 1
mstruct str {
	CD ds "cd"
	BS ds "\x1b7" + // カーソル位置保存
		"\x1b[D" +  // カーソル位置左へ
		" " +
		"\x1b8" + // カーソル位置復帰
		"\x1b[D" // カーソル位置左へ
	TITLE ds "ORANGE Operating System Ver 1.00 Copyright (C) 2020 PicoSoft"
	PROMPT_SD ds "\x1b[32mS:\x1b[37m"
	PROMPT_FL ds "\x1b[33mF:\x1b[37m"
	PROMPT ds ">"
	SLASH ds "/"
	EXE ds ".exe"
	SD ds "s:"
	FL ds "f:"
	MON ds "mon"
	TRUE ds "true"
	SETUP_EXE ds "f:/setup.exe"
}
alias str.ROOT, str.SLASH
mstruct path {
	PATH rb MAX_PATH
}
mstruct env {
	RESTART rb 5 // "true"でOS再起動
	SD rb 5 // "true"でSDマウント中
	DRIVE rb 3 // "f":, "s:"
	PATH_F rb MAX_PATH // f:のカレントパス
	PATH_S rb MAX_PATH // s:のカレントパス
}
mstruct key {
	BUF rb KEY_BUF_SIZE
}
mstruct work {
	PROMPT rb MAX_STRING
	P1 rb MAX_STRING
	BUF rb KEY_BUF_SIZE
	C rb 1
}
mstruct tm {
	SEC rb 1 // 秒 [0-61] 最大2秒までのうるう秒を考慮
	MIN rb 1 // 分 [0-59]
	HOUR rb 1 // 時 [0-23]
	MDAY rb 1 // 日 [1-31]
	MON rb 1 // 月 [0-11]
	YEAR rb 1 // 年 [1900からの経過年数]
	WDAY rb 1 // 曜日 [0:日 1:月 ... 6:土]
	YDAY rb 2 // 年内の通し日数 [0-365] ビッグエンディアンで格納
	ISDST rb 1 // 夏時間が無効であれば0
}
mstruct stat {
	MODE rb 1
	ATIME rb 20
	MTIME rb 20
	CTIME rb 20
	SIZE rb 15
	INT32SIZE rb 4
}

main()
end

def main() {
	var p
	var c
	getenv "RESTART", env.RESTART
	if (mstrcmp(env.RESTART, str.TRUE) == 0) { // 再起動時
		getenv "DRIVE", env.DRIVE // カレントドライブ取得
		getenv "PATH_F", env.PATH_F // カレントディレクトリ取得
		getenv "PATH_S", env.PATH_S // カレントディレクトリ取得
	} else { // 初回起動時
		mstrcpy(env.DRIVE, str.FL) // カレントドライブはフラッシュメモリー
		mstrcpy(env.PATH_F, str.ROOT)
		mstrcpy(env.PATH_S, str.ROOT)
		cls
		mprint str.TITLE
		print
		restart(str.SETUP_EXE)
	}
	cursor 1
	print
	dispFunction()
	prompt()
	mprint work.PROMPT
	p = key.BUF
	clt
	dispDate()
	while TRUE
		c = inkey()
		if (30000 <= tickms()) {
			clt
			dispDate()
		} else if (c == -1) {
			continue
		} else if (c == 0x08) {
			p = backSpace(p)
		} else if (c == '\r') {
			print
			p[0] = 0
			getArg(key.BUF, 0, work.BUF)
			exec(work.BUF)
			mset(key.BUF, 0, KEY_BUF_SIZE)
			p = key.BUF
		} else if (' ' <= c) {
			print chr$(c);
			p[0] = c
			p = p + 1
		}
	wend
}

' 日付を表示します。
def dispDate() {
	var h
	var m
	if (wifiStatus() != WL_CONNECTED) {
		return
	}
	localtime(tm.SEC)
	h = tm.HOUR[0]
	m = tm.MIN[0]
	print "\x1b7";
	locate 75, 24
	print "\x1b[32m";
	mprint mstrf("%02d:%02d", h, m)
	print "\x1b[37m";
	print "\x1b8";
}

' ファンクションキーを表示します。
def dispFunction() {
	var i
	print "\x1b7"; // カーソル位置保存
	locate 0, 24
	print " ";
	for i = 1 to 4
		print "\x1b[46m\x1b[30m";
		print " F";
		print i;
		print "  ";
		print "\x1b[40m\x1b[37m";
		print " ";
	next
	print " ";
	for i = 5 to 8
		print "\x1b[46m\x1b[30m";
		print " F";
		print i;
		print "  ";
		print "\x1b[40m\x1b[37m";
		print " ";
	next
	print " ";
	print "\x1b[46m\x1b[30m";
	print " F9 ";
	print "\x1b[40m\x1b[37m";
	print " ";
	for i = 10 to 12
		print "\x1b[46m\x1b[30m";
		print " F";
		print i;
		print " ";
		print "\x1b[40m\x1b[37m";
		print " ";
	next
	print "\x1b[1;24r"; // スクロール範囲設定
	print "\x1b8"; // カーソル位置復帰
}

' バックスペースの処理を行います。
def backSpace(p) {
	if (p == key.BUF) {
		return p
	}
	p[0] = 0
	p = p - 1
	mprint(str.BS)
	return p
}

' コマンドを実行します。
def exec(cmd) {
	getArg(key.BUF, 1, work.P1)
	if (mstrcmp(cmd, str.SD) == 0) { // s:
		print
		getenv "SD", env.SD
		if (mstrcmp(env.SD, str.TRUE) == 0) { // SDカードマウント中
			mstrcpy(env.DRIVE, str.SD)
			prompt()
		}
	} else if (mstrcmp(cmd, str.FL) == 0) { // f:
		print
		mstrcpy(env.DRIVE, str.FL)
		prompt()
 	} else if (mstrcmp(cmd, str.MON) == 0) {
		setenv "MON", str.TRUE
		end
	} else if (cmd[0] != 0) {
		command(cmd)
	}
	mprint work.PROMPT
}

' 外部コマンドを実行します。
def command(name) {
	var rc
	if (mstrrchr(name, '.') == -1) {
		mstrcat(name, str.EXE)
	}
	getFullPath(path.PATH, name)
    rc = fstat(path.PATH, stat.MODE)
	if (rc == -1 || stat.MODE[0] == 1) { // フラッシュメモリーのルートから再検索
		if (name[0] == '/' || name[1] == ':') {
			print "Command not found"
			print
			return
		}
		mstrcpy(path.PATH, str.FL)
		mstrcat(path.PATH, str.SLASH)
		mstrcat(path.PATH, name)
		rc = fstat(path.PATH, stat.MODE)
		if (rc == -1) {
			print "Command not found"
			print
			return
		}
	}
	setenv "RESTART", str.TRUE
	setenv "DRIVE", env.DRIVE
	setenv "PATH_F", env.PATH_F
	setenv "PATH_S", env.PATH_S
	setenv "COMMAND", key.BUF
	restart(path.PATH)
}

' 指定したプログラムを実行した後にOSを再起動します。
def restart(p) {
	setenv "RESTART", str.TRUE
	setenv "DRIVE", env.DRIVE
	setenv "PATH_F", env.PATH_F
	setenv "PATH_S", env.PATH_S
	setenv "COMMAND", key.BUF
	chain p
}

' n番目の引数を取得します。
def getArg(p, n, arg) {
	var i
	var j
	var c
	for j = 0 to n
		for i = 0 to MAX_STRING
			c = p[0]
			p = p + 1
			if (c = ' ' || c = 0) {
				break
			}
			arg[i] = c
		next
	next
	arg[i] = 0
}

' プロンプト文字列を構築します。
def prompt() {
	if (mstrcmp(env.DRIVE, str.FL) == 0) {
		mstrcpy(work.PROMPT, str.PROMPT_FL)
		mstrcat(work.PROMPT, env.PATH_F)
	} else {
		mstrcpy(work.PROMPT, str.PROMPT_SD)
		mstrcat(work.PROMPT, env.PATH_S)
	}
	mstrcat(work.PROMPT, str.PROMPT)
}

' 完全パス名を作ります。
def getFullPath(fullPath, name) {
	var p
	var currentPath
	p = name
	if (p[1] == ':') { // ドライブ指定あり
		fullPath[0] = p[0]
		fullPath[1] = p[1]
		fullPath[2] = 0
		p = p + 2
	} else {
		mstrcpy(fullPath, env.DRIVE) // カレントドライブ
	}
	if (p[0] == '/') { // ルートからの指定
		mstrcat(fullPath, p)
		return
	}
	if (fullPath[0] == 'f') {
		currentPath = env.PATH_F
	} else {
		currentPath = env.PATH_S
	}
	mstrcat(fullPath, currentPath)
	if (mstrcmp(currentPath, str.ROOT) != 0) {
		mstrcat(fullPath, str.SLASH)
	}
	mstrcat(fullPath, p)
}
