'
' ORANGE Operating System
' configコマンド
' Copyright (C) 2020 by PicoSoft
'
' config <key> <value>
' config.sysを作成します。
'
const TRUE = 1
const CR = 0x0d
const LF = 0x0a
const SPACE = 0x20
const MAX_PATH = 128
const MAX_STRING = 128
mstruct str {
	CRLF ds "\r\n"
	EQUAL ds "="
	CONFIG_FILE ds "f:/config.sys"
}
mstruct env {
	COMMAND rb MAX_PATH
}
mstruct work {
	P1 rb 128
	P2 rb 128
	C rb 1
	KEY rb MAX_STRING
	VALUE rb MAX_STRING
}
mstruct data {
	SSID ds "SSID"
	SSID_VALUE rb MAX_STRING
	PASSWORD ds "PASSWORD"
	PASSWORD_VALUE rb MAX_STRING
	KBSET ds "KBSET"
	KBSET_VALUE rb MAX_STRING
}

main()
end

def main() {
	var file
	getenv "COMMAND", env.COMMAND // コマンドライン取得
	getArg(env.COMMAND, 1, work.P1) // 1番目のパラメーター取得
	getArg(env.COMMAND, 2, work.P2) // 2番目のパラメーター取得
	if (work.P1[0] == 0 || work.P2[0] == 0) {
		print "config <key> <value>"
		end
	}

	// config.sysを読んでおく
	readConfig()

	// 指定データを上書き
	if (mstrcmp(work.P1, data.SSID) == 0) {
		mstrcpy(data.SSID_VALUE, work.P2)
	}
	if (mstrcmp(work.P1, data.PASSWORD) == 0) {
		mstrcpy(data.PASSWORD_VALUE, work.P2)
	}
	if (mstrcmp(work.P1, data.KBSET) == 0) {
		mstrcpy(data.KBSET_VALUE, work.P2)
	}

	// config.sysに書き込む
	file = fopen(str.CONFIG_FILE, 1)
	if (file = -1) {
		end
	}

	fwrite(file, data.SSID, mstrlen(data.SSID))
	fwrite(file, str.EQUAL, 1)
	fwrite(file, data.SSID_VALUE, mstrlen(data.SSID_VALUE))
	fwrite(file, str.CRLF, 2)

	fwrite(file, data.PASSWORD, mstrlen(data.PASSWORD))
	fwrite(file, str.EQUAL, 1)
	fwrite(file, data.PASSWORD_VALUE, mstrlen(data.PASSWORD_VALUE))
	fwrite(file, str.CRLF, 2)

	fwrite(file, data.KBSET, mstrlen(data.KBSET))
	fwrite(file, str.EQUAL, 1)
	fwrite(file, data.KBSET_VALUE, mstrlen(data.KBSET_VALUE))
	fwrite(file, str.CRLF, 2)

	fclose(file)
}

' n番目の引数を取得します。
def getArg(p, n, arg) {
	var i
	var j
	var c
	for j = 0 to n
		for i = 0 to 255
			c = p[0]
			p = p + 1
			if (c = ' ' || c = 0) {
				break
			}
			arg[i] = c
		next
	next
	arg[i] = 0
}

' config.sysを読み込みます。
def readConfig() {
	var file
	var rc
	file = fopen(str.CONFIG_FILE, 0)
	if (file != -1) {
		while TRUE
			rc = readLine(file, work.KEY, work.VALUE)
			if (mstrcmp(work.KEY, data.SSID) == 0) {
				mstrcpy(data.SSID_VALUE, work.VALUE)
			}
			if (mstrcmp(work.KEY, data.PASSWORD) == 0) {
				mstrcpy(data.PASSWORD_VALUE, work.VALUE)
			}
			if (mstrcmp(work.KEY, data.KBSET) == 0) {
				mstrcpy(data.KBSET_VALUE, work.VALUE)
			}
			if (rc == -1) {
				break
			}
		wend
		fclose(file)
	}
}

' ファイルから1行読んで、keyとvalueに分解します。
def readLine(file, key, value) {
	var rc
	var i
	var p
	i = 0
	while i < MAX_STRING
		rc = fread(file, work.C, 1)
		if (rc != 1 || work.C[0] == '\n') {
			break
		}
		if (' ' < work.C[0]) {
			key[i] = work.C[0]
			i = i + 1
		}
	wend
	key[i] = 0
	p = mstrchr(key, '=')
	if (p != -1) {
		p[0] = 0
		mstrcpy(value, p + 1)
	}
	if (rc != 1) {
		return -1
	} else {
		return 0
	}
}
