'
' ORANGE Operating System
' dirコマンド
' Copyright (C) 2020 PicoSoft
'
const TRUE = 1
const MAX_PATH = 128
const FILE_MAX = 100
mstruct path {
	PATH rb MAX_PATH
}
mstruct env {
	DRIVE rb 3 // "f":, "s:"
	PATH_F rb MAX_PATH // f:のカレントパス
	PATH_S rb MAX_PATH // s:のカレントパス
}
mstruct stat {
	MODE rb 1
	ATIME rb 20
	MTIME rb 20
	CTIME rb 20
	SIZE rb 15
	INT32SIZE rb 4
}
mstruct dirInfo {
	BUF rb 100 * 30
	SORT.w rw 100
}

main()
end

def main() {
	var p
	var count
	var i
	var path
	path = getCurrentPath()
	getFullPath(path.PATH, path)
	count = dir(path.PATH, dirInfo.BUF)
	makePointerArray(count, dirInfo.SORT.w, dirInfo.BUF)
	qsort(dirInfo.SORT.w, 0, count - 1)
	for i = 0 to count - 1
		printFileInfo(dirInfo.SORT.w[i])
	next
}

' ソート用にポインター配列を作ります。
def makePointerArray(count, d.w, s) {
	var i
	for i = 0 to count - 1
		d.w[i] = s
		s = s + mstrlen(s) + 1
	next
}

' ファイル情報を表示します。
def printFileInfo(p) {
	getFullPath(path.PATH, p)
	fstat(path.PATH, stat.MODE)
	mprint stat.MTIME
	print "  ";
	if (stat.MODE[0] = 1) {
		print "<dir>          ";
	} else {
		mprint stat.SIZE
		print "  ";
	}
	mprint p
	print
}

' 対象となるドライブのカレントパスを取得します。
def getCurrentPath() {
	if (mstrcmp(env.DRIVE, mstrf("f:")) == 0) {
		return env.PATH_F
	} else {
		return env.PATH_S
	}
}

' 完全パス名を作ります。
def getFullPath(fullPath, name) {
	var p
	var currentPath
	getenv "DRIVE", env.DRIVE // カレントドライブ取得
	getenv "PATH_F", env.PATH_F // カレントディレクトリ取得
	getenv "PATH_S", env.PATH_S // カレントディレクトリ取得
	p = name
	if (p[1] == ':') { // ドライブ指定あり
		fullPath[0] = p[0]
		fullPath[1] = p[1]
		fullPath[2] = 0
		p = p + 2
	} else {
		mstrcpy(fullPath, env.DRIVE) // カレントドライブ
	}
	if (p[0] == '/') { // ルートからの指定
		mstrcat(fullPath, p)
		return
	}
	if (fullPath[0] == 'f') {
		currentPath = env.PATH_F
	} else {
		currentPath = env.PATH_S
	}
	mstrcat(fullPath, currentPath)
	if (mstrcmp(currentPath, mstrf("/")) != 0) {
		mstrcat(fullPath, mstrf("/"))
	}
	mstrcat(fullPath, p)
}

' クイックソートを実行します。
def qsort(p.w, left, right) {
	var pivot
	var i
	var j
	pivot = p.w[(left + right) / 2]
	i = left
	j = right
	while TRUE
		while compare(p.w[i], pivot)
			i = i + 1
		wend
		while compare(pivot, p.w[j])
			j = j - 1
		wend
		if (j <= i) {
			break
		}
		swap(p.w, i, j)
		i = i + 1
		j = j - 1
	wend
	if (left < i - 1) {
		qsort(p.w, left, i - 1)
	}
	if (j + 1 < right) {
		qsort(p.w, j + 1, right)
	}
}

' 要素を比較します。
def compare(p, q) {
	return mstrcmp(p, q) < 0
}

' 要素を交換します。
def swap(p.w, i, j) {
	var temp
	temp = p.w[i]
	p.w[i] = p.w[j]
	p.w[j] = temp
}
