'
' ORANGE Operating System
' renコマンド
' Copyright (C) 2020 PicoSoft
' ren <元ファイル名> <新ファイル名>
' ファイル名を変更します。
'
const MAX_PATH = 128
mstruct str {
	SLASH ds "/"
}
alias str.ROOT, str.SLASH
mstruct path {
	OLD_PATH rb MAX_PATH
	NEW_PATH rb MAX_PATH
}
mstruct env {
	DRIVE rb 3 // "f":, "s:"
	PATH_F rb MAX_PATH // f:のカレントパス
	PATH_S rb MAX_PATH // s:のカレントパス
}
mstruct work {
	COMMAND rb MAX_PATH
	NAME rb MAX_PATH
}

main()
end

def main() {
	getenv "COMMAND", work.COMMAND // コマンドライン取得

	getArg(work.COMMAND, 1, work.NAME) // 1番目のパラメーター取得
	if (work.NAME[0] == 0) {
		errorEnd()
	}
	getFullPath(path.OLD_PATH, work.NAME)

	getArg(work.COMMAND, 2, work.NAME) // 2番目のパラメーター取得
	if (work.NAME[0] == 0) {
		errorEnd()
	}
	getFullPath(path.NEW_PATH, work.NAME)

	rename(path.OLD_PATH, path.NEW_PATH)
}

' エラーメッセージを表示して終了します。
def errorEnd() {
	print "ren <old file name> <new file name>"
	end
}

' n番目の引数を取得します。
def getArg(p, n, arg) {
	var i
	var j
	var c
	for j = 0 to n
		for i = 0 to 255
			c = p[0]
			p = p + 1
			if (c = ' ' || c = 0) {
				break
			}
			arg[i] = c
		next
	next
	arg[i] = 0
}

' 完全パス名を作ります。
def getFullPath(fullPath, name) {
	var p
	var currentPath
	getenv "DRIVE", env.DRIVE // カレントドライブ取得
	getenv "PATH_F", env.PATH_F // カレントディレクトリ取得
	getenv "PATH_S", env.PATH_S // カレントディレクトリ取得
	p = name
	if (p[1] == ':') { // ドライブ指定あり
		fullPath[0] = p[0]
		fullPath[1] = p[1]
		fullPath[2] = 0
		p = p + 2
	} else {
		mstrcpy(fullPath, env.DRIVE) // カレントドライブ
	}
	if (p[0] == '/') { // ルートからの指定
		mstrcat(fullPath, p)
		return
	}
	if (fullPath[0] == 'f') {
		currentPath = env.PATH_F
	} else {
		currentPath = env.PATH_S
	}
	mstrcat(fullPath, currentPath)
	if (mstrcmp(currentPath, str.ROOT) != 0) {
		mstrcat(fullPath, str.SLASH)
	}
	mstrcat(fullPath, p)
}
